
////////////////////////////////////////////////////////////////
//Aufgabe 3 aus Kapitel Nebenläufige Programmierung
///////////////////////////////////////////////////////////////

String message;
int messagexLo, messageyLo;//Text Begrenzung links oben
int messagexRu, messageyRu;//Text Begrenzung rechts unten
int titelNummer;
int anzahlSchlangen;
ArrayList<Schlange> schlangen; 

///////////////////////////////////////////////////////////////

void setup() {
  //fullScreen();  
  size(1200, 1200);
  smooth();
  frameRate(40);
  textSize(24);
  colorMode(HSB, 360, 255, 255);

  anzahlSchlangen = 20;
  schlangen = new ArrayList<Schlange>(20);

  messagexLo = 50;
  messageyLo= height-200;
  messagexRu = width -100;
  messageyRu = height - 50;
  message = "";
  titelNummer = 0;
}

///////////////////////////////////////////////////////////////

void draw() { 
  background(0); 

  for (int i=0; i<schlangen.size(); i++) {
    Schlange s = schlangen.get(i);
    s.update();
    s.display();
  }

  // wenn genug Schlangen, dann lösche gelegentlich eine...
  if ((random(0, 1)<0.01) && (schlangen.size() == anzahlSchlangen))
    schlangeLoeschen();

  if (frameCount % 20 == 1) thread("schlangeErzeugen");

  if (frameCount % 300 == 1) thread("webzugriff"); //  webzugriff();
  
  //if (frameCount % 300 == 1) webzugriff(); // alternativ: ohne neuen Thread

  fill(360, 0, 160);
  text(message, messagexLo, messageyLo, messagexRu, messageyRu);
}

//////////////////////////////////////////////////////

void schlangeErzeugen() {
  //  delay((int)random(50,2000));
  if (schlangen.size() < anzahlSchlangen)
    schlangen.add(new Schlange((int) random(width-50), (int) random(height-50), 70));
}

void schlangeLoeschen() {
  if (schlangen.size()>0) 
    schlangen.remove((int)random(0, schlangen.size()-1));
}

//////////////////////////////////////////////////////
// Nachrichtenheader als RSS-Feed esen
//////////////////////////////////////////////////////

void webzugriff() {
  
  
  String url = "http://www.tagesschau.de/xml/rss2";
  XML rss = loadXML(url);

  // bearbeite die XML-Daten
  XML[] titleXMLElements = rss.getChildren("channel/item/description");
  String[] titles = new String[titleXMLElements.length];
  for (int i = 0; i < titleXMLElements.length; i++) {
    String title = titleXMLElements[i].getContent();
    // speichere alle Titel in einem Array
    titles[i] = title;
  }

  saveXML(rss, "test.txt");
  

  // Description anzeigen
  if (titleXMLElements.length>0) {
    message = titles[min(titelNummer, titleXMLElements.length-1)];
    titelNummer = (titelNummer+1)%20;//maximal 20 verschiedene Descriptions anzeigen
  }
}